/* auto-generated, do not modify */
#include "config.h"

#include "fu-efi-struct.h"
#include "fu-byte-array.h"
#include "fu-mem-private.h"
#include "fu-string.h"

#ifdef G_LOG_DOMAIN
  #undef G_LOG_DOMAIN
#endif
#define G_LOG_DOMAIN "FuStruct"
/* getters */
const fwupd_guid_t *
fu_struct_efi_file_get_name(GByteArray *st)
{
    g_return_val_if_fail(st != NULL, NULL);
    return (const fwupd_guid_t *) (st->data + 0);
}
guint8
fu_struct_efi_file_get_hdr_checksum(GByteArray *st)
{
    g_return_val_if_fail(st != NULL, 0x0);
    return st->data[16];
}
guint8
fu_struct_efi_file_get_data_checksum(GByteArray *st)
{
    g_return_val_if_fail(st != NULL, 0x0);
    return st->data[17];
}
guint8
fu_struct_efi_file_get_type(GByteArray *st)
{
    g_return_val_if_fail(st != NULL, 0x0);
    return st->data[18];
}
guint8
fu_struct_efi_file_get_attrs(GByteArray *st)
{
    g_return_val_if_fail(st != NULL, 0x0);
    return st->data[19];
}
guint32
fu_struct_efi_file_get_size(GByteArray *st)
{
    g_return_val_if_fail(st != NULL, 0x0);
    return fu_memread_uint24(st->data + 20, G_LITTLE_ENDIAN);
}
static guint8
fu_struct_efi_file_get_state(GByteArray *st)
{
    g_return_val_if_fail(st != NULL, 0x0);
    return st->data[23];
}

/* setters */
void
fu_struct_efi_file_set_name(GByteArray *st, const fwupd_guid_t *value)
{
    g_return_if_fail(st != NULL);
    g_return_if_fail(value != NULL);
    memcpy(st->data + 0, value, sizeof(*value));
}
void
fu_struct_efi_file_set_hdr_checksum(GByteArray *st, guint8 value)
{
    g_return_if_fail(st != NULL);
    st->data[16] = value;
}
void
fu_struct_efi_file_set_data_checksum(GByteArray *st, guint8 value)
{
    g_return_if_fail(st != NULL);
    st->data[17] = value;
}
void
fu_struct_efi_file_set_type(GByteArray *st, guint8 value)
{
    g_return_if_fail(st != NULL);
    st->data[18] = value;
}
void
fu_struct_efi_file_set_attrs(GByteArray *st, guint8 value)
{
    g_return_if_fail(st != NULL);
    st->data[19] = value;
}
void
fu_struct_efi_file_set_size(GByteArray *st, guint32 value)
{
    g_return_if_fail(st != NULL);
    fu_memwrite_uint24(st->data + 20, value, G_LITTLE_ENDIAN);
}
static void
fu_struct_efi_file_set_state(GByteArray *st, guint8 value)
{
    g_return_if_fail(st != NULL);
    st->data[23] = value;
}
GByteArray *
fu_struct_efi_file_new(void)
{
    GByteArray *st = g_byte_array_new();
    fu_byte_array_set_size(st, 24, 0x0);
    fu_struct_efi_file_set_state(st, 0xF8);
    return st;
}

gchar *
fu_struct_efi_file_to_string(GByteArray *st)
{
    g_autoptr(GString) str = g_string_new("FuEfiFile:\n");
    g_return_val_if_fail(st != NULL, NULL);
    {
        g_autofree gchar *tmp = fwupd_guid_to_string(fu_struct_efi_file_get_name(st), FWUPD_GUID_FLAG_MIXED_ENDIAN);
        g_string_append_printf(str, "  name: %s\n", tmp);
    }
    g_string_append_printf(str, "  hdr_checksum: 0x%x\n", (guint) fu_struct_efi_file_get_hdr_checksum(st));
    g_string_append_printf(str, "  data_checksum: 0x%x\n", (guint) fu_struct_efi_file_get_data_checksum(st));
    g_string_append_printf(str, "  type: 0x%x\n", (guint) fu_struct_efi_file_get_type(st));
    g_string_append_printf(str, "  attrs: 0x%x\n", (guint) fu_struct_efi_file_get_attrs(st));
    g_string_append_printf(str, "  size: 0x%x\n", (guint) fu_struct_efi_file_get_size(st));
    g_string_append_printf(str, "  state: 0x%x\n", (guint) fu_struct_efi_file_get_state(st));
    if (str->len > 0)
        g_string_set_size(str, str->len - 1);
    return g_string_free(g_steal_pointer(&str), FALSE);
}
GByteArray *
fu_struct_efi_file_parse(const guint8 *buf, gsize bufsz, gsize offset, GError **error)
{
    g_autoptr(GByteArray) st = g_byte_array_new();
    g_autofree gchar *str = NULL;
    g_return_val_if_fail(buf != NULL, NULL);
    g_return_val_if_fail(error == NULL || *error == NULL, NULL);
    if (!fu_memchk_read(bufsz, offset, 24, error)) {
        g_prefix_error(error, "invalid struct FuEfiFile: ");
        return NULL;
    }
    g_byte_array_append(st, buf + offset, 24);
    if (fu_struct_efi_file_get_state(st) != 0xF8) {
        g_set_error_literal(error,
                            G_IO_ERROR,
                            G_IO_ERROR_INVALID_DATA,
                            "constant FuEfiFile.state was not valid, expected 0xF8");
        return NULL;
    }
    str = fu_struct_efi_file_to_string(st);
    g_debug("%s", str);
    return g_steal_pointer(&st);
}
gboolean
fu_struct_efi_file_validate(const guint8 *buf, gsize bufsz, gsize offset, GError **error)
{
    GByteArray st = {.data = (guint8 *) buf + offset, .len = bufsz - offset, };
    g_return_val_if_fail(buf != NULL, FALSE);
    g_return_val_if_fail(error == NULL || *error == NULL, FALSE);
    if (!fu_memchk_read(bufsz, offset, 24, error)) {
        g_prefix_error(error, "invalid struct FuEfiFile: ");
        return FALSE;
    }
    if (fu_struct_efi_file_get_state(&st) != 0xF8) {
        g_set_error_literal(error,
                            G_IO_ERROR,
                            G_IO_ERROR_INVALID_DATA,
                            "constant FuEfiFile.state was not valid");
        return FALSE;
    }
    return TRUE;
}
/* getters */
guint32
fu_struct_efi_section_get_size(GByteArray *st)
{
    g_return_val_if_fail(st != NULL, 0x0);
    return fu_memread_uint24(st->data + 0, G_LITTLE_ENDIAN);
}
guint8
fu_struct_efi_section_get_type(GByteArray *st)
{
    g_return_val_if_fail(st != NULL, 0x0);
    return st->data[3];
}

/* setters */
void
fu_struct_efi_section_set_size(GByteArray *st, guint32 value)
{
    g_return_if_fail(st != NULL);
    fu_memwrite_uint24(st->data + 0, value, G_LITTLE_ENDIAN);
}
void
fu_struct_efi_section_set_type(GByteArray *st, guint8 value)
{
    g_return_if_fail(st != NULL);
    st->data[3] = value;
}
GByteArray *
fu_struct_efi_section_new(void)
{
    GByteArray *st = g_byte_array_new();
    fu_byte_array_set_size(st, 4, 0x0);
    return st;
}

gchar *
fu_struct_efi_section_to_string(GByteArray *st)
{
    g_autoptr(GString) str = g_string_new("FuEfiSection:\n");
    g_return_val_if_fail(st != NULL, NULL);
    g_string_append_printf(str, "  size: 0x%x\n", (guint) fu_struct_efi_section_get_size(st));
    g_string_append_printf(str, "  type: 0x%x\n", (guint) fu_struct_efi_section_get_type(st));
    if (str->len > 0)
        g_string_set_size(str, str->len - 1);
    return g_string_free(g_steal_pointer(&str), FALSE);
}
GByteArray *
fu_struct_efi_section_parse(const guint8 *buf, gsize bufsz, gsize offset, GError **error)
{
    g_autoptr(GByteArray) st = g_byte_array_new();
    g_autofree gchar *str = NULL;
    g_return_val_if_fail(buf != NULL, NULL);
    g_return_val_if_fail(error == NULL || *error == NULL, NULL);
    if (!fu_memchk_read(bufsz, offset, 4, error)) {
        g_prefix_error(error, "invalid struct FuEfiSection: ");
        return NULL;
    }
    g_byte_array_append(st, buf + offset, 4);
    str = fu_struct_efi_section_to_string(st);
    g_debug("%s", str);
    return g_steal_pointer(&st);
}
gboolean
fu_struct_efi_section_validate(const guint8 *buf, gsize bufsz, gsize offset, GError **error)
{
    g_return_val_if_fail(buf != NULL, FALSE);
    g_return_val_if_fail(error == NULL || *error == NULL, FALSE);
    if (!fu_memchk_read(bufsz, offset, 4, error)) {
        g_prefix_error(error, "invalid struct FuEfiSection: ");
        return FALSE;
    }
    return TRUE;
}
/* getters */
const fwupd_guid_t *
fu_struct_efi_section_guid_defined_get_name(GByteArray *st)
{
    g_return_val_if_fail(st != NULL, NULL);
    return (const fwupd_guid_t *) (st->data + 0);
}
guint16
fu_struct_efi_section_guid_defined_get_offset(GByteArray *st)
{
    g_return_val_if_fail(st != NULL, 0x0);
    return fu_memread_uint16(st->data + 16, G_LITTLE_ENDIAN);
}
guint16
fu_struct_efi_section_guid_defined_get_attr(GByteArray *st)
{
    g_return_val_if_fail(st != NULL, 0x0);
    return fu_memread_uint16(st->data + 18, G_LITTLE_ENDIAN);
}

/* setters */
void
fu_struct_efi_section_guid_defined_set_name(GByteArray *st, const fwupd_guid_t *value)
{
    g_return_if_fail(st != NULL);
    g_return_if_fail(value != NULL);
    memcpy(st->data + 0, value, sizeof(*value));
}
void
fu_struct_efi_section_guid_defined_set_offset(GByteArray *st, guint16 value)
{
    g_return_if_fail(st != NULL);
    fu_memwrite_uint16(st->data + 16, value, G_LITTLE_ENDIAN);
}
void
fu_struct_efi_section_guid_defined_set_attr(GByteArray *st, guint16 value)
{
    g_return_if_fail(st != NULL);
    fu_memwrite_uint16(st->data + 18, value, G_LITTLE_ENDIAN);
}
GByteArray *
fu_struct_efi_section_guid_defined_new(void)
{
    GByteArray *st = g_byte_array_new();
    fu_byte_array_set_size(st, 20, 0x0);
    return st;
}

gchar *
fu_struct_efi_section_guid_defined_to_string(GByteArray *st)
{
    g_autoptr(GString) str = g_string_new("FuEfiSectionGuidDefined:\n");
    g_return_val_if_fail(st != NULL, NULL);
    {
        g_autofree gchar *tmp = fwupd_guid_to_string(fu_struct_efi_section_guid_defined_get_name(st), FWUPD_GUID_FLAG_MIXED_ENDIAN);
        g_string_append_printf(str, "  name: %s\n", tmp);
    }
    g_string_append_printf(str, "  offset: 0x%x\n", (guint) fu_struct_efi_section_guid_defined_get_offset(st));
    g_string_append_printf(str, "  attr: 0x%x\n", (guint) fu_struct_efi_section_guid_defined_get_attr(st));
    if (str->len > 0)
        g_string_set_size(str, str->len - 1);
    return g_string_free(g_steal_pointer(&str), FALSE);
}
GByteArray *
fu_struct_efi_section_guid_defined_parse(const guint8 *buf, gsize bufsz, gsize offset, GError **error)
{
    g_autoptr(GByteArray) st = g_byte_array_new();
    g_autofree gchar *str = NULL;
    g_return_val_if_fail(buf != NULL, NULL);
    g_return_val_if_fail(error == NULL || *error == NULL, NULL);
    if (!fu_memchk_read(bufsz, offset, 20, error)) {
        g_prefix_error(error, "invalid struct FuEfiSectionGuidDefined: ");
        return NULL;
    }
    g_byte_array_append(st, buf + offset, 20);
    str = fu_struct_efi_section_guid_defined_to_string(st);
    g_debug("%s", str);
    return g_steal_pointer(&st);
}
gboolean
fu_struct_efi_section_guid_defined_validate(const guint8 *buf, gsize bufsz, gsize offset, GError **error)
{
    g_return_val_if_fail(buf != NULL, FALSE);
    g_return_val_if_fail(error == NULL || *error == NULL, FALSE);
    if (!fu_memchk_read(bufsz, offset, 20, error)) {
        g_prefix_error(error, "invalid struct FuEfiSectionGuidDefined: ");
        return FALSE;
    }
    return TRUE;
}
/* getters */
const fwupd_guid_t *
fu_struct_efi_volume_get_zero_vector(GByteArray *st)
{
    g_return_val_if_fail(st != NULL, NULL);
    return (const fwupd_guid_t *) (st->data + 0);
}
const fwupd_guid_t *
fu_struct_efi_volume_get_guid(GByteArray *st)
{
    g_return_val_if_fail(st != NULL, NULL);
    return (const fwupd_guid_t *) (st->data + 16);
}
guint64
fu_struct_efi_volume_get_length(GByteArray *st)
{
    g_return_val_if_fail(st != NULL, 0x0);
    return fu_memread_uint64(st->data + 32, G_LITTLE_ENDIAN);
}
static guint32
fu_struct_efi_volume_get_signature(GByteArray *st)
{
    g_return_val_if_fail(st != NULL, 0x0);
    return fu_memread_uint32(st->data + 40, G_LITTLE_ENDIAN);
}
guint32
fu_struct_efi_volume_get_attrs(GByteArray *st)
{
    g_return_val_if_fail(st != NULL, 0x0);
    return fu_memread_uint32(st->data + 44, G_LITTLE_ENDIAN);
}
guint16
fu_struct_efi_volume_get_hdr_len(GByteArray *st)
{
    g_return_val_if_fail(st != NULL, 0x0);
    return fu_memread_uint16(st->data + 48, G_LITTLE_ENDIAN);
}
guint16
fu_struct_efi_volume_get_checksum(GByteArray *st)
{
    g_return_val_if_fail(st != NULL, 0x0);
    return fu_memread_uint16(st->data + 50, G_LITTLE_ENDIAN);
}
guint16
fu_struct_efi_volume_get_ext_hdr(GByteArray *st)
{
    g_return_val_if_fail(st != NULL, 0x0);
    return fu_memread_uint16(st->data + 52, G_LITTLE_ENDIAN);
}
static guint8
fu_struct_efi_volume_get_revision(GByteArray *st)
{
    g_return_val_if_fail(st != NULL, 0x0);
    return st->data[55];
}

/* setters */
void
fu_struct_efi_volume_set_zero_vector(GByteArray *st, const fwupd_guid_t *value)
{
    g_return_if_fail(st != NULL);
    g_return_if_fail(value != NULL);
    memcpy(st->data + 0, value, sizeof(*value));
}
void
fu_struct_efi_volume_set_guid(GByteArray *st, const fwupd_guid_t *value)
{
    g_return_if_fail(st != NULL);
    g_return_if_fail(value != NULL);
    memcpy(st->data + 16, value, sizeof(*value));
}
void
fu_struct_efi_volume_set_length(GByteArray *st, guint64 value)
{
    g_return_if_fail(st != NULL);
    fu_memwrite_uint64(st->data + 32, value, G_LITTLE_ENDIAN);
}
static void
fu_struct_efi_volume_set_signature(GByteArray *st, guint32 value)
{
    g_return_if_fail(st != NULL);
    fu_memwrite_uint32(st->data + 40, value, G_LITTLE_ENDIAN);
}
void
fu_struct_efi_volume_set_attrs(GByteArray *st, guint32 value)
{
    g_return_if_fail(st != NULL);
    fu_memwrite_uint32(st->data + 44, value, G_LITTLE_ENDIAN);
}
void
fu_struct_efi_volume_set_hdr_len(GByteArray *st, guint16 value)
{
    g_return_if_fail(st != NULL);
    fu_memwrite_uint16(st->data + 48, value, G_LITTLE_ENDIAN);
}
void
fu_struct_efi_volume_set_checksum(GByteArray *st, guint16 value)
{
    g_return_if_fail(st != NULL);
    fu_memwrite_uint16(st->data + 50, value, G_LITTLE_ENDIAN);
}
void
fu_struct_efi_volume_set_ext_hdr(GByteArray *st, guint16 value)
{
    g_return_if_fail(st != NULL);
    fu_memwrite_uint16(st->data + 52, value, G_LITTLE_ENDIAN);
}
static void
fu_struct_efi_volume_set_revision(GByteArray *st, guint8 value)
{
    g_return_if_fail(st != NULL);
    st->data[55] = value;
}
GByteArray *
fu_struct_efi_volume_new(void)
{
    GByteArray *st = g_byte_array_new();
    fu_byte_array_set_size(st, 56, 0x0);
    fu_struct_efi_volume_set_signature(st, 0x4856465F);
    fu_struct_efi_volume_set_revision(st, 0x02);
    return st;
}

gchar *
fu_struct_efi_volume_to_string(GByteArray *st)
{
    g_autoptr(GString) str = g_string_new("FuEfiVolume:\n");
    g_return_val_if_fail(st != NULL, NULL);
    {
        g_autofree gchar *tmp = fwupd_guid_to_string(fu_struct_efi_volume_get_zero_vector(st), FWUPD_GUID_FLAG_MIXED_ENDIAN);
        g_string_append_printf(str, "  zero_vector: %s\n", tmp);
    }
    {
        g_autofree gchar *tmp = fwupd_guid_to_string(fu_struct_efi_volume_get_guid(st), FWUPD_GUID_FLAG_MIXED_ENDIAN);
        g_string_append_printf(str, "  guid: %s\n", tmp);
    }
    g_string_append_printf(str, "  length: 0x%x\n", (guint) fu_struct_efi_volume_get_length(st));
    g_string_append_printf(str, "  signature: 0x%x\n", (guint) fu_struct_efi_volume_get_signature(st));
    g_string_append_printf(str, "  attrs: 0x%x\n", (guint) fu_struct_efi_volume_get_attrs(st));
    g_string_append_printf(str, "  hdr_len: 0x%x\n", (guint) fu_struct_efi_volume_get_hdr_len(st));
    g_string_append_printf(str, "  checksum: 0x%x\n", (guint) fu_struct_efi_volume_get_checksum(st));
    g_string_append_printf(str, "  ext_hdr: 0x%x\n", (guint) fu_struct_efi_volume_get_ext_hdr(st));
    g_string_append_printf(str, "  revision: 0x%x\n", (guint) fu_struct_efi_volume_get_revision(st));
    if (str->len > 0)
        g_string_set_size(str, str->len - 1);
    return g_string_free(g_steal_pointer(&str), FALSE);
}
GByteArray *
fu_struct_efi_volume_parse(const guint8 *buf, gsize bufsz, gsize offset, GError **error)
{
    g_autoptr(GByteArray) st = g_byte_array_new();
    g_autofree gchar *str = NULL;
    g_return_val_if_fail(buf != NULL, NULL);
    g_return_val_if_fail(error == NULL || *error == NULL, NULL);
    if (!fu_memchk_read(bufsz, offset, 56, error)) {
        g_prefix_error(error, "invalid struct FuEfiVolume: ");
        return NULL;
    }
    g_byte_array_append(st, buf + offset, 56);
    if (fu_struct_efi_volume_get_signature(st) != 0x4856465F) {
        g_set_error_literal(error,
                            G_IO_ERROR,
                            G_IO_ERROR_INVALID_DATA,
                            "constant FuEfiVolume.signature was not valid, expected 0x4856465F");
        return NULL;
    }
    if (fu_struct_efi_volume_get_revision(st) != 0x02) {
        g_set_error_literal(error,
                            G_IO_ERROR,
                            G_IO_ERROR_INVALID_DATA,
                            "constant FuEfiVolume.revision was not valid, expected 0x02");
        return NULL;
    }
    str = fu_struct_efi_volume_to_string(st);
    g_debug("%s", str);
    return g_steal_pointer(&st);
}
gboolean
fu_struct_efi_volume_validate(const guint8 *buf, gsize bufsz, gsize offset, GError **error)
{
    GByteArray st = {.data = (guint8 *) buf + offset, .len = bufsz - offset, };
    g_return_val_if_fail(buf != NULL, FALSE);
    g_return_val_if_fail(error == NULL || *error == NULL, FALSE);
    if (!fu_memchk_read(bufsz, offset, 56, error)) {
        g_prefix_error(error, "invalid struct FuEfiVolume: ");
        return FALSE;
    }
    if (fu_struct_efi_volume_get_signature(&st) != 0x4856465F) {
        g_set_error_literal(error,
                            G_IO_ERROR,
                            G_IO_ERROR_INVALID_DATA,
                            "constant FuEfiVolume.signature was not valid");
        return FALSE;
    }
    if (fu_struct_efi_volume_get_revision(&st) != 0x02) {
        g_set_error_literal(error,
                            G_IO_ERROR,
                            G_IO_ERROR_INVALID_DATA,
                            "constant FuEfiVolume.revision was not valid");
        return FALSE;
    }
    return TRUE;
}
/* getters */
guint32
fu_struct_efi_volume_block_map_get_num_blocks(GByteArray *st)
{
    g_return_val_if_fail(st != NULL, 0x0);
    return fu_memread_uint32(st->data + 0, G_LITTLE_ENDIAN);
}
guint32
fu_struct_efi_volume_block_map_get_length(GByteArray *st)
{
    g_return_val_if_fail(st != NULL, 0x0);
    return fu_memread_uint32(st->data + 4, G_LITTLE_ENDIAN);
}

/* setters */
void
fu_struct_efi_volume_block_map_set_num_blocks(GByteArray *st, guint32 value)
{
    g_return_if_fail(st != NULL);
    fu_memwrite_uint32(st->data + 0, value, G_LITTLE_ENDIAN);
}
void
fu_struct_efi_volume_block_map_set_length(GByteArray *st, guint32 value)
{
    g_return_if_fail(st != NULL);
    fu_memwrite_uint32(st->data + 4, value, G_LITTLE_ENDIAN);
}
GByteArray *
fu_struct_efi_volume_block_map_new(void)
{
    GByteArray *st = g_byte_array_new();
    fu_byte_array_set_size(st, 8, 0x0);
    return st;
}

gchar *
fu_struct_efi_volume_block_map_to_string(GByteArray *st)
{
    g_autoptr(GString) str = g_string_new("FuEfiVolumeBlockMap:\n");
    g_return_val_if_fail(st != NULL, NULL);
    g_string_append_printf(str, "  num_blocks: 0x%x\n", (guint) fu_struct_efi_volume_block_map_get_num_blocks(st));
    g_string_append_printf(str, "  length: 0x%x\n", (guint) fu_struct_efi_volume_block_map_get_length(st));
    if (str->len > 0)
        g_string_set_size(str, str->len - 1);
    return g_string_free(g_steal_pointer(&str), FALSE);
}
GByteArray *
fu_struct_efi_volume_block_map_parse(const guint8 *buf, gsize bufsz, gsize offset, GError **error)
{
    g_autoptr(GByteArray) st = g_byte_array_new();
    g_autofree gchar *str = NULL;
    g_return_val_if_fail(buf != NULL, NULL);
    g_return_val_if_fail(error == NULL || *error == NULL, NULL);
    if (!fu_memchk_read(bufsz, offset, 8, error)) {
        g_prefix_error(error, "invalid struct FuEfiVolumeBlockMap: ");
        return NULL;
    }
    g_byte_array_append(st, buf + offset, 8);
    str = fu_struct_efi_volume_block_map_to_string(st);
    g_debug("%s", str);
    return g_steal_pointer(&st);
}
gboolean
fu_struct_efi_volume_block_map_validate(const guint8 *buf, gsize bufsz, gsize offset, GError **error)
{
    g_return_val_if_fail(buf != NULL, FALSE);
    g_return_val_if_fail(error == NULL || *error == NULL, FALSE);
    if (!fu_memchk_read(bufsz, offset, 8, error)) {
        g_prefix_error(error, "invalid struct FuEfiVolumeBlockMap: ");
        return FALSE;
    }
    return TRUE;
}
/* getters */
const fwupd_guid_t *
fu_struct_efi_signature_list_get_type(GByteArray *st)
{
    g_return_val_if_fail(st != NULL, NULL);
    return (const fwupd_guid_t *) (st->data + 0);
}
guint32
fu_struct_efi_signature_list_get_list_size(GByteArray *st)
{
    g_return_val_if_fail(st != NULL, 0x0);
    return fu_memread_uint32(st->data + 16, G_LITTLE_ENDIAN);
}
guint32
fu_struct_efi_signature_list_get_header_size(GByteArray *st)
{
    g_return_val_if_fail(st != NULL, 0x0);
    return fu_memread_uint32(st->data + 20, G_LITTLE_ENDIAN);
}
guint32
fu_struct_efi_signature_list_get_size(GByteArray *st)
{
    g_return_val_if_fail(st != NULL, 0x0);
    return fu_memread_uint32(st->data + 24, G_LITTLE_ENDIAN);
}

/* setters */
void
fu_struct_efi_signature_list_set_type(GByteArray *st, const fwupd_guid_t *value)
{
    g_return_if_fail(st != NULL);
    g_return_if_fail(value != NULL);
    memcpy(st->data + 0, value, sizeof(*value));
}
void
fu_struct_efi_signature_list_set_list_size(GByteArray *st, guint32 value)
{
    g_return_if_fail(st != NULL);
    fu_memwrite_uint32(st->data + 16, value, G_LITTLE_ENDIAN);
}
void
fu_struct_efi_signature_list_set_header_size(GByteArray *st, guint32 value)
{
    g_return_if_fail(st != NULL);
    fu_memwrite_uint32(st->data + 20, value, G_LITTLE_ENDIAN);
}
void
fu_struct_efi_signature_list_set_size(GByteArray *st, guint32 value)
{
    g_return_if_fail(st != NULL);
    fu_memwrite_uint32(st->data + 24, value, G_LITTLE_ENDIAN);
}
GByteArray *
fu_struct_efi_signature_list_new(void)
{
    GByteArray *st = g_byte_array_new();
    fu_byte_array_set_size(st, 28, 0x0);
    return st;
}

gchar *
fu_struct_efi_signature_list_to_string(GByteArray *st)
{
    g_autoptr(GString) str = g_string_new("FuEfiSignatureList:\n");
    g_return_val_if_fail(st != NULL, NULL);
    {
        g_autofree gchar *tmp = fwupd_guid_to_string(fu_struct_efi_signature_list_get_type(st), FWUPD_GUID_FLAG_MIXED_ENDIAN);
        g_string_append_printf(str, "  type: %s\n", tmp);
    }
    g_string_append_printf(str, "  list_size: 0x%x\n", (guint) fu_struct_efi_signature_list_get_list_size(st));
    g_string_append_printf(str, "  header_size: 0x%x\n", (guint) fu_struct_efi_signature_list_get_header_size(st));
    g_string_append_printf(str, "  size: 0x%x\n", (guint) fu_struct_efi_signature_list_get_size(st));
    if (str->len > 0)
        g_string_set_size(str, str->len - 1);
    return g_string_free(g_steal_pointer(&str), FALSE);
}
GByteArray *
fu_struct_efi_signature_list_parse(const guint8 *buf, gsize bufsz, gsize offset, GError **error)
{
    g_autoptr(GByteArray) st = g_byte_array_new();
    g_autofree gchar *str = NULL;
    g_return_val_if_fail(buf != NULL, NULL);
    g_return_val_if_fail(error == NULL || *error == NULL, NULL);
    if (!fu_memchk_read(bufsz, offset, 28, error)) {
        g_prefix_error(error, "invalid struct FuEfiSignatureList: ");
        return NULL;
    }
    g_byte_array_append(st, buf + offset, 28);
    str = fu_struct_efi_signature_list_to_string(st);
    g_debug("%s", str);
    return g_steal_pointer(&st);
}
gboolean
fu_struct_efi_signature_list_validate(const guint8 *buf, gsize bufsz, gsize offset, GError **error)
{
    g_return_val_if_fail(buf != NULL, FALSE);
    g_return_val_if_fail(error == NULL || *error == NULL, FALSE);
    if (!fu_memchk_read(bufsz, offset, 28, error)) {
        g_prefix_error(error, "invalid struct FuEfiSignatureList: ");
        return FALSE;
    }
    return TRUE;
}
